/********************************************************************************** 
  This file is part of the kde-game 'kjumpingCube'

  Copyright (C) 1998 by Matthias Kiefer <Matthias.Kiefer@stud.uni-karlsruhe.de>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  *******************************************************************************/  


#ifndef Cube_H
#define Cube_H

#include <qframe.h>


class QPalette;
 

class Cube : public QFrame
{
    Q_OBJECT
public:
    Cube(QWidget *parent=0, const char *name=0,int max_Value=0);
    ~Cube();
    void setMaxValue(int);
    void setOwner(int);
    void setValue(int);
    int getOwner();
    int value();

    static void setColors(QPalette *player1, QPalette *player2);
    static void setAktPlayer(int);
    static int getAktPlayer();

public slots:
    void increase();
    void decrease();
    void reset();
    void updateColor();


signals:
    void playerChanged(int newplayer);  
    void gameEnded(int winner);
    void overflow();

protected:
    void mouseReleaseEvent( QMouseEvent * );
    void timerEvent(QTimerEvent *);
    void drawContents(QPainter *);

private:
    int owner;             // Besitzer 
    bool isWorking;        // gerade am berlaufen?
    int points,maxValue;   // Wert und maximaler Wert des Wrfels
    int overflowTimer;     // ID des Timers, der Overflow auslst

    static int akt_player; // aktueller Spieler
    static int player1_points; // Anzahl der player 1 gehrenden Wrfel
    static int player2_points; // Anzahl der player 2 gehrenden Wrfel
    static int areWorking;  // Anzahl der berlaufenden Wrfel
    static int cube_counter;  // Anzahl der Wrfel insgesamt
    static bool gameover;
    static QPalette *color1,*color2;
    
    void startOverflow();
};

#endif // Cube_H
















